/**************************ciilib1.0.1***********************************
 *									*
 *        Character to Inline Image Conversion Library (CIILIB)		*
 *               Copyright (c) 1995, Valentin Shopov.			*
 *									*
 *	Encoder for Character by Inline Image of HTML on HTTP		*
 *		by valentin@rs.aubg.bg (Valentin Shopov)		*
 ************************************************************************/

#include <stdio.h>
/*
int CII_isPRE;
*/

unsigned char *
EUC_TO_CII(src,dst,ctype,ubase)
unsigned char *src, *dst;
char *ctype,*ubase;
{	register unsigned char *sp,*dp;
	int isPlain;

	isPlain = strcasecmp(ctype,"text/plain") == 0;

	for(sp=src, dp=dst; *sp; ){
/*
	if(CII_isPRE>0 && isPlain){
	sprintf(dp,"<PRE>");
	dp+=5;
	CII_isPRE=-1;
	}
*/
		if( *sp & 0x80 ){
			if(sp[1] & 0x80){
				sprintf(dp,"<IMG SRC=\"%s%x%x\">",ubase,sp[0],sp[1]);
				dp += strlen(dp); sp += 2;
			}else	sp++;
		}else{	if(isPlain){ switch(*sp) {
				case '<' : 
					sprintf(dp,"&lt;");
					dp += 4; sp++;
					break;
				case '>' : 
					sprintf(dp,"&gt;");
					dp += 4; sp++;
					break;
				case '&' : 
					sprintf(dp,"&amp;");
					dp += 5; sp++;
					break;
				case '"' : 
					sprintf(dp,"&quot;");
					dp += 6; sp++;
					break;
				default:
					*dp++ = *sp++;
					break;
				    }
			}else *dp++ = *sp++;
		}
	}
	*dp = 0;
	return dst;
}

TO_CII(any,gr,ctype,ubase)
	unsigned char *any,*gr;
	char *ctype,*ubase;
{	char *euc;
	int euclen;
	euclen = (strlen("<IMG SRC=\"a1a1\">")+strlen(ubase))*strlen(any)/2+1; 
	euc = (char*)malloc(euclen);
	TO_EUC(any,euc);
	EUC_TO_CII(euc,gr,ctype,ubase);
	free(euc);
}

extern char *xbmsrc[];
extern int xbmind[];
static char xbmbuf[500];
static char *getCII(name)
	char *name;
{	int i,euc,kanind;
	char *gkand,*curxbm;
	gkand = xbmbuf;
	sscanf(name,"%x",&euc);
	kanind=(euc/256-161)*94 + euc%256-161;
	if(xbmind[kanind] == -1) return 0;
	curxbm = xbmsrc[xbmind[kanind]];
	sprintf(gkand,"#define %s_width 16\n#define %s_height 16\nstatic char %s_bits[] = {\n\0",name,name,name);
	for(i = 0; i< 32; i++) {
	sprintf(gkand+strlen(gkand),"0x%02x,\0",(unsigned char)curxbm[i]);
	}
	sprintf(gkand+strlen(gkand)-1,"};\n\0");
	return gkand;
}

putCII(tc,vno,gkan)
	FILE *tc;
	char *gkan;
{	char *data,*getCII();
	int size;
	int leng = 0;

	if( (data = getCII(gkan)) == 0 )
		return 0;
	size = strlen(data);
	leng += HTTP_putHeader(tc,vno,"image/x-xbitmap",size);
	leng += fwrite(data,1,size,tc);
	return leng;
}

